'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _yeomanGenerator = require('yeoman-generator');

var _yeomanGenerator2 = _interopRequireDefault(_yeomanGenerator);

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _utilities = require('../utilities');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var copyOverComponent = function copyOverComponent(context) {
  var igniteConfig = (0, _utilities.getConfig)();
  // copy component template
  context.fs.copyTpl(context.templatePath('component.js.template'), context.destinationPath('./App/Components/' + context.name + '.js'), { name: context.name });

  // copy component style template
  context.fs.copyTpl(context.templatePath('component-style.js.template'), context.destinationPath('./App/Components/Styles/' + context.name + 'Style.js'), { name: context.name });

  // create a component ava test
  if (_ramda2.default.pathEq(['options', 'testing'], 'ava', igniteConfig)) {
    context.fs.copyTpl(context.templatePath('component-test.js.template'), context.destinationPath('./Tests/Components/' + context.name + 'Test.js'), { name: context.name });
  }
};

var ComponentGenerator = function (_Generators$Base) {
  _inherits(ComponentGenerator, _Generators$Base);

  function ComponentGenerator(args, options) {
    _classCallCheck(this, ComponentGenerator);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ComponentGenerator).call(this, args, options));

    _this.argument('name', { type: String, required: true });
    return _this;
  }

  _createClass(ComponentGenerator, [{
    key: 'generateComponent',
    value: function generateComponent() {
      // Copy over component files.
      copyOverComponent(this);
    }
  }, {
    key: 'end',
    value: function end() {
      console.log('Time to get cooking! 🍽 ');
    }
  }]);

  return ComponentGenerator;
}(_yeomanGenerator2.default.Base);

module.exports = ComponentGenerator;