#! /usr/bin/env node

'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _yeomanGenerator = require('yeoman-generator');

var _yeomanGenerator2 = _interopRequireDefault(_yeomanGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListviewGenerator = function (_Generators$Base) {
  _inherits(ListviewGenerator, _Generators$Base);

  function ListviewGenerator(args, options) {
    _classCallCheck(this, ListviewGenerator);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ListviewGenerator).call(this, args, options));

    _this.argument('name', { type: String, required: true });
    return _this;
  }

  _createClass(ListviewGenerator, [{
    key: 'copyOverListView',
    value: function copyOverListView(type) {
      // sections or no?
      if (type === 'Sectioned List') {
        this.fs.copyTpl(this.templatePath('listview-sections.js.template'), this.destinationPath('./App/Containers/' + this.name + '.js'), { name: this.name });
      } else {
        this.fs.copyTpl(this.templatePath('listview.js.template'), this.destinationPath('./App/Containers/' + this.name + '.js'), { name: this.name });
      }

      // grid or no?
      if (type === 'Grid List') {
        this.fs.copyTpl(this.templatePath('gridlistview-style.js.template'), this.destinationPath('./App/Containers/Styles/' + this.name + 'Style.js'), { name: this.name });
      } else {
        this.fs.copyTpl(this.templatePath('listview-style.js.template'), this.destinationPath('./App/Containers/Styles/' + this.name + 'Style.js'), { name: this.name });
      }
    }
  }, {
    key: 'prompting',
    value: function prompting() {
      var _this2 = this;

      var prompts = [{
        type: 'list',
        name: 'listviewtype',
        message: 'What kind of listview would you like to generate?',
        choices: ['Row List', 'Grid List', 'Sectioned List'],
        store: true
      }];

      return this.prompt(prompts).then(function (answers) {
        _this2.copyOverListView(answers.listviewtype);
      });
    }
  }, {
    key: 'end',
    value: function end() {
      this.log('Time to get cooking! 🍽 ');
    }
  }]);

  return ListviewGenerator;
}(_yeomanGenerator2.default.Base);

module.exports = ListviewGenerator;